import { jsxs as n, jsx as r } from "react/jsx-runtime";
import { useRef as M, useState as S, useEffect as z } from "react";
import E from "../../hooks/useUploadFiles.js";
import { cn as f } from "../../utils/functions.js";
import { c as C } from "../../index-XXb8XwCi.js";
import P from "./CircleProgressLoading.js";
import "../../axios-f2q_J-wz.js";
import "../../clsx-7d8NmkQq.js";
import "../../utils/components/RenderEach.js";
import "../../utils/components/RenderIf.js";
import "../Icons.js";
import "./variants.js";
import "../../index-xVF7D3FM.js";
import "../../motion-dVICNqWI.js";
import "../../SVGVisualElement-aqO4D4Z5.js";
import "../../LayoutGroupContext-3euHzeKi.js";
const H = ({ multiple: u, inputProps: h, setValue: d, currentId: s, fieldError: x, triggerValidation: m, baseURL: g, label: v }) => {
  const { handleUploadImage: y, loadingProgress: w } = E(), c = M(null), [i, p] = S([]), N = (l, t = 2) => {
    if (l === 0)
      return "0 Bytes";
    const e = 1024, o = t < 0 ? 0 : t, a = ["Bytes", "KB", "MB", "GB", "TB", "PB", "EB", "ZB", "YB"], _ = Math.floor(Math.log(l) / Math.log(e));
    return parseFloat((l / Math.pow(e, _)).toFixed(o)) + " " + a[_];
  }, F = () => {
    c.current && (c.current.value = null);
  }, B = (l) => {
    const t = i.filter((e) => e.id !== l);
    p(t), d(s, t), m(s);
  }, b = async (l) => {
    const t = [];
    for (let e = 0; e < l.target.files.length; e++) {
      const o = l.target.files[e];
      try {
        const a = await y(g, o);
        t.push({
          id: `file_${Date.now()}_${e}`,
          ...a,
          filename: o.name,
          filetype: o.type,
          datetime: o.lastModifiedDate.toLocaleString("en-IN"),
          filesize: N(o.size)
        });
      } catch (a) {
        console.error("Error uploading file:", a);
      }
    }
    p((e) => [...e, ...t]), d(s, [...i, ...t]), m(s);
  };
  return z(() => {
    F();
  }, [i]), /* @__PURE__ */ n("div", { className: f("_flex _flex-col _rounded-md"), "data-id": "input-wrapper", children: [
    /* @__PURE__ */ r("label", { className: f("_font-main _text-common _text-input"), children: v }),
    /* @__PURE__ */ n("div", { className: "_flex", children: [
      /* @__PURE__ */ n("label", { className: "_relative _inline-block _cursor-pointer _overflow-hidden _rounded-l-md _bg-primary _px-4 _py-2 _text-white _outline-none", children: [
        "Seleccionar archivo",
        /* @__PURE__ */ r("input", { ...h, ref: c, type: "file", className: "_hidden", multiple: u, onChange: b })
      ] }),
      /* @__PURE__ */ r(
        "input",
        {
          type: "text",
          value: i && i.length > 0 ? `${i.length} archivo(s)` : "No hay archivo seleccionado",
          className: "_flex-grow _rounded-r-md _border _border-gray-300 _px-4 _py-2 _outline-none",
          readOnly: !0
        }
      )
    ] }),
    i && i.map((l) => {
      const { id: t, filename: e, filesize: o } = l;
      return /* @__PURE__ */ n("div", { className: "_mt-4 _flex _items-center", children: [
        /* @__PURE__ */ r(P, { value: w }),
        /* @__PURE__ */ n("div", { className: "_ml-4 _flex _w-[full] _flex-col _overflow-hidden", children: [
          /* @__PURE__ */ r("p", { className: "_truncate", children: e }),
          /* @__PURE__ */ n("span", { children: [
            "Peso: ",
            o
          ] })
        ] }),
        /* @__PURE__ */ r("button", { className: "_ml-2 _w-[90px] _rounded _bg-primary _px-3 _py-1 _text-white", onClick: () => B(t), children: "Eliminar" })
      ] }, t);
    }),
    /* @__PURE__ */ r(C, { message: x })
  ] });
};
export {
  H as default
};
